/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
/*
 * Linux Desktop Testing Project http://ldtp.freedesktop.org
 *
 * Author:
 *    Veerapuram Varadhan <v.varadhan@gmail.com>
 *
 * Copyright 2004 - 2006 Novell, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ldtp-memory.h"

/*
 *  ldtp_memory_do_alloc: Allocate memory, if required.
 *    This function tries to re-use the allocated memory.
 *
 *  Returns: initialized memory
 *
 */
char*
ldtp_memory_do_alloc (char* src, size_t len, size_t prev_len)
{
	char* dest = NULL;

	if (!src || len > prev_len) {
		if (!src) {
			dest = (char *) malloc (sizeof (char) * len);
			memset (dest, 0x00, len);
		}
		else {
			dest = realloc (src, sizeof (char) * len);
			memset (dest + prev_len, 0x00, prev_len - len);
		}
	} else if (prev_len > len) {
		memset (src+len, 0x00, prev_len - len);
		dest = src;
	} else
		dest = src;

	if (src)
		memset (src, 0x00, len);
	return dest;
}
