/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
/*
 * Linux Desktop Testing Project http://ldtp.freedesktop.org
 *
 * Author:
 *    Poornima Nayak <pnayak@novell.com>
 *    Nagappan A <nagappan@gmail.com>
 *
 * Copyright 2004 - 2006 Novell, Inc.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef _LDTP_STATE_H
#define _LDTP_STATE_H

#include <cspi/spi.h>

typedef struct state_struct_def
{
 	int states_count;
	int states[10];
}object_state;
 
typedef struct _LDTPState LDTPState;
typedef enum _LDTPStateId LDTPStateId;

enum _LDTPStateId {
	LDTP_STATE_INVALID = SPI_STATE_INVALID,
	LDTP_STATE_ACTIVE = SPI_STATE_ACTIVE,
	LDTP_STATE_ARMED = SPI_STATE_ARMED,
	LDTP_STATE_BUSY = SPI_STATE_BUSY,
	LDTP_STATE_CHECKED = SPI_STATE_CHECKED,
	LDTP_STATE_COLLAPSED = SPI_STATE_COLLAPSED,
	LDTP_STATE_DEFUNCT = SPI_STATE_DEFUNCT,
	LDTP_STATE_EDITABLE = SPI_STATE_EDITABLE,
	LDTP_STATE_ENABLED = SPI_STATE_ENABLED,
	LDTP_STATE_EXPANDABLE = SPI_STATE_EXPANDABLE,
	LDTP_STATE_EXPANDED = SPI_STATE_EXPANDED,
	LDTP_STATE_FOCUSABLE = SPI_STATE_FOCUSABLE,
	LDTP_STATE_FOCUSED = SPI_STATE_FOCUSED,
	LDTP_STATE_HORIZONTAL = SPI_STATE_HORIZONTAL,
	LDTP_STATE_ICONIFIED = SPI_STATE_ICONIFIED,
	LDTP_STATE_MODAL = SPI_STATE_MODAL,
	LDTP_STATE_MULTILINE = SPI_STATE_MULTI_LINE,
	LDTP_STATE_MULTISELECTABLE = SPI_STATE_MULTISELECTABLE,
	LDTP_STATE_OPAQUE = SPI_STATE_OPAQUE,
	LDTP_STATE_PRESSED = SPI_STATE_PRESSED,
	LDTP_STATE_RESIZABLE = SPI_STATE_RESIZABLE,
	LDTP_STATE_SELECTABLE = SPI_STATE_SELECTABLE,
	LDTP_STATE_SELECTED = SPI_STATE_SELECTED,
	LDTP_STATE_SENSITIVE = SPI_STATE_SENSITIVE,
	LDTP_STATE_SHOWING = SPI_STATE_SHOWING,
	LDTP_STATE_SINGLELINE = SPI_STATE_SINGLE_LINE,
	LDTP_STATE_STALE = SPI_STATE_STALE,
	LDTP_STATE_TRANSIENT = SPI_STATE_TRANSIENT,
	LDTP_STATE_VERTICAL = SPI_STATE_VERTICAL,
	LDTP_STATE_VISIBLE = SPI_STATE_VISIBLE,
	LDTP_STATE_MANAGESDESCENDANTS = SPI_STATE_MANAGES_DESCENDANTS,
	LDTP_STATE_INDETERMINATE = SPI_STATE_INDETERMINATE/*,*/
	/*LDTP_STATE_TRUNCATED = SPI_STATE_TRUNCATED,*/
	/*LDTP_STATE_REQUIRED = SPI_STATE_REQUIRED,*/
	/*LDTP_STATE_INVALIDENTRY = SPI_STATE_INVALIDENTRY,*/
	/*LDTP_STATE_SUPPORTSAUTOCOMPLETION = SPI_STATE_SUPPORTSAUTOCOMPLETION,*/
	/*LDTP_STATE_SELECTABLETEXT = SPI_STATE_SELECTABLETEXT,*/
	/*LDTP_STATE_ISDEFAULT = SPI_STATE_ISDEFAULT,*/
	/*LDTP_STATE_VISITED = SPI_STATE_VISITED*/
};

struct _LDTPState {
	LDTPStateId state_id;
	char* state_name;
};

LDTPStateId ldtp_state_get_state_id (const char* state_name);
void ldtp_state_destroy_state_table (void);

#endif
